// PointSprite.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_POINTS
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLE_STRIP
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=384

#version 120
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

uniform vec3 vertex[128];
uniform int indexList[128];
//uniform int order;
uniform int indexListSize;

varying in vec3 positionIn[];
varying in float pointSizeIn[];
varying out vec3 position;

void main(void){
    vec4 nX = gl_ModelViewProjectionMatrix * vec4(1, 0, 0, 0);
    vec4 nY = gl_ModelViewProjectionMatrix * vec4(0, 1, 0, 0);
    vec4 nZ = gl_ModelViewProjectionMatrix * vec4(0, 0, 1, 0);

    float psize = pointSizeIn[0];
    int flip = 0;
    if (psize < 0){
	flip = 1;
	psize *= -1;
    }

    nX *= psize;
    nY *= psize;
    nZ *= psize;

    int current = 0;
    int itemCount = 0;
    while (true){
	int index = indexList[current];
	if (index == -1){
	    if (itemCount != 0){
		EndPrimitive();
		itemCount = 0;
	    }
	}
	else {
	    gl_Position = gl_PositionIn[0] + nX * vertex[index].x + nY * vertex[index].y + nZ * vertex[index].z;
	    EmitVertex();
	    if (flip == 1 && itemCount == 0) EmitVertex();
	    itemCount++;
	}
	    
	current ++;
	if (current >= indexListSize) break;
    }
}
