// PointSprite.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_POINTS
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLE_STRIP
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=4

#version 120
// neccesary for attribute int
#extension GL_EXT_geometry_shader4 : enable 
#extension GL_EXT_gpu_shader4 : enable

uniform float aspectAngleFactor; 

varying in vec3 positionIn[];
varying in int subIndexIn[];
varying in float pointSizeIn[];

varying in vec3 normalIn[];
varying in vec3 tangentIn[];
varying in vec3 binormalIn[];

varying out vec3 position;

void main(void){

    vec4 tangent = vec4(tangentIn[0], 0);
    vec4 binormal = vec4(binormalIn[0], 0);

    vec4 offset[4] = vec4[]((-tangent-binormal), (+tangent-binormal),
			    (-tangent+binormal), (+tangent+binormal));
    
    vec4 texCoord[4] = vec4[]
	(vec4(0,0,0,0), vec4(1,0,0,0), vec4(0,1,0,0), vec4(1,1,0, 0)); 

    float psize = pointSizeIn[0];// * aspectAngleFactor;

    for(int i = 0; i < gl_VerticesIn; i++){
	gl_FrontColor = gl_FrontColorIn[i];

	gl_TexCoord[0] = texCoord[0];

	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[i] + offset[0] * psize);
	position = positionIn[i] + vec3(offset[0]*psize);
	EmitVertex();
	gl_TexCoord[0] = texCoord[1];
	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[i] + offset[1] * psize);
	position = positionIn[i] + vec3(offset[1]*psize);
	EmitVertex();
	gl_TexCoord[0] = texCoord[2];
	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[i] + offset[2] * psize);
	position = positionIn[i] + vec3(offset[2]*psize);
	EmitVertex();
	gl_TexCoord[0] = texCoord[3];
	gl_Position = gl_ModelViewProjectionMatrix * (gl_PositionIn[i] + offset[3] * psize);
	position = positionIn[i] + vec3(offset[3]*psize);
	EmitVertex();
    }
    
    EndPrimitive();
}

